#include <algorithm>
#include <cstdio>
#include <string>
#include <cstdlib>
#include <vector>
using namespace std;

struct date {
	bool operator < (const date & dt) const  {
		if (y == dt.y) {
			if (m == dt.m)
				return d < dt.d;
			return m < dt.m;
		}
		return y < dt.y;
	};
	bool operator != (const date & dt) const {
		return d!=dt.d || m!=dt.m || y!=dt.y;
	};
	int d;
	int m;
	int y;
};

vector<date> V;

int M[12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

bool leap(int y) {
	if (y%4 != 0)
		return false;
	if (y%100 == 0 && y%400 != 0)
		return false;
	return true;
}

void foo2(int d, int m, int y) {
	if (y<1700 || 2299<y)
		return;
	if (m == 2 && d == 29) {
		if (!leap(y))
			return;
	} else if (M[m-1] < d)
		return;
	date x = { d, m, y };

	V.push_back(x);
}

void foo(char * D, char * M, char * Y) {
	int d, m, y;

    d = strlen(D);
	if (d<1 || 2<d)
		return;

	d = atoi(D);
	if (d<1 || 31<d)
		return;

	m = strlen(M);
	if (m<1 || 2<m)
		return;

	m = atoi(M);
	if (m<1 || 12<m)
		return;

	y = strlen(Y);
	if (y == 4) {
        y = atoi(Y);
		foo2(d, m, y);
	} else if (y==1 || y==2) {
		y = atoi(Y);
		for (int i=1700+y; i<2300; i+=100)
			foo2(d, m, i);
	}
}

void check(char * str, int a, int b, int c, int d, int e, int f) {
	char s1[16], s2[16], s3[16];
	int i;
	
	for (i=a; i<b; ++i)
		s1[i-a] = str[i];
	s1[i-a] = 0;

	for (i=c; i<d; ++i)
		s2[i-c] = str[i];
	s2[i-c] = 0;
    
	for (i=e; i<f; ++i)
		s3[i-e] = str[i];
	s3[i-e] = 0;

	foo(s1, s2, s3);
	foo(s1, s3, s2);
	foo(s2, s1, s3);
	foo(s2, s3, s1);
	foo(s3, s1, s2);
	foo(s3, s2, s1);
}

int elapsed(int d, int m, int y)
{
	int ret = 0;
	ret += 31-15+1;
	ret += 30 + 31;
	ret += (y-1582-1)*365;
	ret += (y-1)/4 - 1582/4;
	ret -= (y-1)/100 - 1582/100;
	ret += (y-1)/400 - 1582/400;
	for (int i=0; i<m; ++i)
		ret += M[i];
	if (m>1 && y%4==0 && (y%100 || y%400==0))
		++ret;
	ret += d;
	return ret;
}


int main() {
	int t;
	scanf("%d", &t);
	int e = elapsed(4, 10, 2001);

	for (int z=1; z<=t; ++z) {
		char str[16];
		int n;

		scanf("%s", str);

		V.clear();
		n = strlen(str);

		int a = -1, b = -1;

		for (int i=0; i<n; ++i) {
			if (str[i]<'0' || '9'<str[i]) {
				if (a != -1)
					b = i;
				else
					a = i;
			}
		}

	//	printf("Scenario #%d:\n", z);


        if (a != -1 && b != -1)
			check(str, 0, a, a+1, b, b+1, n);
		else for (int i=1; i+1<n; ++i)
			for (int j=i+1; j<n; ++j)
				check(str, 0, i, i, j, j, n);

		if (V.empty())
			printf("BRAK\n");
		else {
			sort(V.begin(), V.end());
			int k = V.size();
			for (int i=0; i<k; ++i) {
				if (i==0 || V[i-1]!=V[i])
					printf("%d\n", elapsed(V[i].d, V[i].m-1, V[i].y) - e);
				//	printf("%d %d %d\n", V[i].d, V[i].m, V[i].y);
			}
		}
		printf("\n");
	}

	return 0;
}
